# Exponential functions

xtensor provides the following exponential functions for xexpressions:

Defined in `xtensor/xmath.hpp`

template <class E>
auto `xt::``exp`(E &&e)

  Natural exponential function.

  Returns an xfunction for the element-wise natural exponential of e.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``exp2`(E &&e)

  Base 2 exponential function.

  Returns an xfunction for the element-wise base 2 exponential of e.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``expm1`(E &&e)

  Natural exponential minus one function.

  Returns an xfunction for the element-wise natural exponential of e, minus 1.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``log`(E &&e)

  Natural logarithm function.

  Returns an xfunction for the element-wise natural logarithm of e.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``log2`(E &&e)

  Base 2 logarithm function.

  Returns an xfunction for the element-wise base 2 logarithm of e.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``log10`(E &&e)

  Base 10 logarithm function.

  Returns an xfunction for the element-wise base 10 logarithm of e.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression

template <class E>
auto `xt::``log1p`(E &&e)

  Natural logarithm of one plus function.

  Returns an xfunction for the element-wise natural logarithm of e, plus 1.

  Return
    an xfunction
  Parameters
    - `e`: an xexpression